gameAlreadyInit = "false"

dofile("map.lua")

function GameSetup()
	if gameAlreadyInit == "false" then
		mappy = loadMap("testmap")
		offsetX = 0
		offsetY = 0
		gameAlreadyInit = "true"
		bGui = true
		bIsToggled = false
		
		mapCursor = Image.load("./Data/Textures/Tiles/MapCursor.PNG")
		mcx = 0
		mcy = 0
		
		entImg = Image.load("./Data/Textures/Ent/entity.png")
		ex = 5
		ey = 5
	end
	cursorTimer = Timer.new(0)
	tt1 = false
end

function GameDraw()
	-- Draw the map :P 
	screen:blit(0, 0, mapbuf, offsetX, offsetY, 480, 272, true)
	
	-- Draw the cursor :)
	if math.mod(mcy, 2) == 0 then
		bcx = mcx * 64
	else
		bcx = (mcx * 64) + 32
	end
	
	screen:blit(bcx, mcy * 16 - offsetY, mapCursor, true)
	
	-- Draw the entity :)
	if math.mod(ey, 2) == 0 then
		ecx = ex * 64
	else
		ecx = (ex * 64) + 32
	end
	
	screen:blit(ecx, ey * 16 - offsetY, entImg, true)

	
	-- Draw the map info stuffs 
	if bGui == true then
		screen:print(10, 10, "DDS:AP (Duelli Della Scheda: Arte Persa) Map Test", white)
		screen:print(10, 20, "Map file: " .. mappy .. ".map", white)
		screen:print(10, 30, "Tileset file: " .. mappy .. ".til", white)
		screen:print(10, 40, "Layer file: " .. mappy .. ".lay", white)
		screen:print(10, 50, "Name: " .. string.sub(MapTitle,1,string.len(MapTitle)-1), white)
		screen:print(10, 60, "Width: " .. MapWidth, white)
		screen:print(10, 70, "Height: " .. MapHeight, white)
		screen:print(10, 80, "Y offset: " .. offsetY, white)
		screen:print(10, 90, "Cursor Pos: " .. mcx .. "," .. mcy, white)
		if bIsToggled == true then
			screen:print(10, 100, "Toggle: On" , white)
		else
			screen:print(10, 100, "Toggle: Off" , white)
		end
	end
	
	screen.flip()
	screen:clear()

end

function GameDoInput()
  	pad = Controls.read()
	cursorTimer:start()
	
  	if pad:circle() then 
		screen:save(getNewScreenShotName())
		
	elseif pad:triangle() and cursorTimer:time() > 50 then
		if bGui == true then
			bGui = false
		else
			bGui = true
		end
		cursorTimer:reset()
	
	elseif pad:cross() and cursorTimer:time() > 50 then
		if bIsToggled == true then
			ex = mcx
			ey = mcy
			bIsToggled = false
		elseif bIsToggled == false then
			if mcx == ex and mcy == ey then
				bIsToggled = true
			end
		end
		cursorTimer:reset()
		
	elseif pad:square() then 
		switchState("Menu")
	
	elseif pad:up() and cursorTimer:time() > 50 then 
		if mcy < 16 and mcy > 0 and offsetY >= 16 then offsetY = offsetY - 16 end
		if mcy > 0 then mcy = mcy - 1 end
		cursorTimer:reset()
	
	elseif pad:down() and cursorTimer:time() > 50 then 
		if mcy >= 15 and mcy < 29 and offsetY <= 208 then offsetY = offsetY + 16 end
		if mcy < 29 then mcy = mcy + 1 end
		cursorTimer:reset()
	
	elseif pad:left() and cursorTimer:time() > 50 then
		if mcx > 0 then mcx = mcx - 1 end
		cursorTimer:reset()
	
	elseif pad:right() and cursorTimer:time() > 50 then
		if mcx < 6 then mcx = mcx + 1 end
		cursorTimer:reset()
	end
end

function GameShutdown()
	screen:clear()
end